/**********************************************************************
 * SQLFreeEnv
 *
 * Do not try to Free Env if there are Dbcs... return an error. Let the
 * Driver Manager do a recursive clean up if it wants.
 *
 **********************************************************************
 *
 * This code was created by Peter Harvey (mostly during Christmas 98/99).
 * This code is LGPL. Please ensure that this message remains in future
 * distributions and uses of this code (thats about all I get out of it).
 * - Peter Harvey pharvey@codebydesign.com
 *
 **********************************************************************/

#include "driver.h"


SQLRETURN SQLFreeEnv( SQLHENV hDrvEnv )
{
    return SQLFreeEnv_( hDrvEnv );
}

SQLRETURN SQLFreeEnv_( SQLHENV hDrvEnv )
{
	HDRVENV hEnv	= (HDRVENV)hDrvEnv;

	/* SANITY CHECKS */
    if( hEnv == SQL_NULL_HENV )
        return SQL_INVALID_HANDLE;

    /* 
     * FREE ALL DEPENDENT DATA AND THIS ENV
     */
    DRVFreeEnv( hDrvEnv );

	return SQL_SUCCESS;
}


